// パレット右上のRGBの値
let paletteR = 255;
let paletteG = 0;
let paletteB = 0;
// RGBの数値
let rgbR = 255;
let rgbG = 0;
let rgbB = 0;
// HSVの数値
let hsvH = 0;
let hsvS = 0;
let hsvV = 255;


// 変換に使用する最大の数値
let maxValue;
// 変換に使用する最小の数値
let minValue;
// 色相バーやパレット上のカーソルを操作するとき、タッチ操作かマウス操作かの判別
let touchFlag = false;

// カラーピッカーの呼び出し
$(function() {
  colorPicker();
});

function colorPicker() {
  // 入力フォームの変更
  $('.js-rgb_input').on('change', function() {
    returnHSV();
  });
  $('.js-hsv_input').on('change', function() {
    returnRGB();
  });

  // 色相バーの操作
  dragHuebar();

  // パレットの操作
  dragPalette();
}

function returnRGB() {
  // HSVの入力フォームの値を取得
  hsvH = parseInt($('#js-num_hsvh').val());
  hsvS = parseInt($('#js-num_hsvs').val());
  hsvV = parseInt($('#js-num_hsvv').val());

  // HSVに不正な値の入力があったときの対応
  if(hsvH < 0 || isNaN(hsvH)) {
    hsvH = 0;
    $('#js-num_hsvh').val(hsvH);
  } else if(hsvH > 360) {
    hsvH = 360;
    $('#js-num_hsvh').val(hsvH);
  }
  if(hsvS < 0 || isNaN(hsvS)) {
    hsvS = 0;
    $('#js-num_hsvs').val(hsvS);
  } else if(hsvS > 255) {
    hsvS = 255;
    $('#js-num_hsvs').val(hsvS);
  }
  if(hsvV < 0 || isNaN(hsvV)) {
    hsvV = 0;
    $('#js-num_hsvv').val(hsvV);
  } else if(hsvV > 255) {
    hsvV = 255;
    $('#js-num_hsvv').val(hsvV);
  }

  // 整数値として扱う
  hsvH = parseInt(hsvH);
  hsvS = parseInt(hsvS);
  hsvV = parseInt(hsvV);

  // 最大値を設定
  maxValue = hsvV;

  // 最小値を設定
  minValue = maxValue - ((hsvS / 255) * maxValue);

  if(hsvH >= 0 && hsvH < 60) {
    rgbR = maxValue;
    rgbG = (hsvH / 60) * (maxValue - minValue) + minValue;
    rgbB = minValue;
  } else if(hsvH >= 60 && hsvH < 120) {
    rgbR = ((120 - hsvH) / 60) * (maxValue - minValue) + minValue;
    rgbG = maxValue;
    rgbB = minValue;
  } else if(hsvH >= 120 && hsvH < 180) {
    rgbR = minValue;
    rgbG = maxValue;
    rgbB = ((hsvH - 120) / 60) * (maxValue - minValue) + minValue;
  } else if(hsvH >= 180 && hsvH < 240) {
    rgbR = minValue;
    rgbG = ((240 - hsvH) / 60) * (maxValue - minValue) + minValue;
    rgbB = maxValue;
  } else if(hsvH >= 240 && hsvH < 300) {
    rgbR = ((hsvH - 240) / 60) * (maxValue - minValue) + minValue;
    rgbG = minValue;
    rgbB = maxValue;
  } else {
    rgbR = maxValue;
    rgbG = minValue;
    rgbB = ((360 - hsvH) / 60) * (maxValue - minValue) + minValue;
  }

  $('#js-num_rgbr').val(parseInt(rgbR));
  $('#js-num_rgbg').val(parseInt(rgbG));
  $('#js-num_rgbb').val(parseInt(rgbB));

  paletteBg();
  hueCircle();
  paletteCircle();
}

function returnHSV() {
  // RGBの数値が大きい順のデータ配列
  let rgbDesc = [];

  // RGBの入力フォームの値を取得
  rgbR = $('#js-num_rgbr').val();
  rgbG = $('#js-num_rgbg').val();
  rgbB = $('#js-num_rgbb').val();

  // RGBに不正な値の入力があったときの対応
  if(rgbR < 0 || isNaN(rgbR)) {
    rgbR = 0;
    $('#js-num_rgbr').val(rgbR);
  } else if(rgbR > 255) {
    rgbR = 255;
    $('#js-num_rgbr').val(rgbR);
  }
  if(rgbG < 0 || isNaN(rgbG)) {
    rgbG = 0;
    $('#js-num_rgbg').val(rgbG);
  } else if(rgbG > 255) {
    rgbG = 255;
    $('#js-num_rgbg').val(rgbG);
  }
  if(rgbB < 0 || isNaN(rgbB)) {
    rgbB = 0;
    $('#js-num_rgbb').val(rgbB);
  } else if(rgbB > 255) {
    rgbB = 255;
    $('#js-num_rgbb').val(rgbB);
  }

  // 整数値として扱う
  rgbR = parseInt(rgbR);
  rgbG = parseInt(rgbG);
  rgbB = parseInt(rgbB);

  // rgbDescにRGBの値が大きい順がわかるように'R','G','B'を入れる
  if(rgbR > rgbG) {
    if(rgbR > rgbB) {
      if(rgbG >= rgbB) {
        rgbDesc = ['R', 'G', 'B'];
      } else {
        rgbDesc = ['R', 'B', 'G'];
      }
    } else {
      rgbDesc = ['B', 'R', 'G'];
    }
  } else {
    if(rgbG > rgbB) {
      if(rgbR >= rgbB) {
        rgbDesc = ['G', 'R', 'B'];
      } else {
        rgbDesc = ['G', 'B', 'R'];
      }
    } else {
      rgbDesc = ['B', 'G', 'R'];
    }
  }

  // 変数rgbDescから最大値・最小値を設定し、HSVを取得し設定

  if(rgbDesc[2] == 'R') {
    minValue = rgbR;
  } else if(rgbDesc[2] == 'G') {
    minValue = rgbG;
  } else {
    minValue = rgbB;
  }

  // 色相を取得し設定する
  if(rgbDesc[0] == 'R') {
    maxValue = rgbR;
    hsvH = 60 * ((rgbG - rgbB) / (maxValue - minValue));
  } else if(rgbDesc[0] == 'G') {
    maxValue = rgbG;
    hsvH = 60 * ((rgbB - rgbR) / (maxValue - minValue)) + 120;
  } else {
    maxValue = rgbB;
    hsvH = 60 * ((rgbR - rgbG) / (maxValue - minValue)) + 240;
  }
  // rgbの値が同じとき、hsvHが数値にならないための処理
  // 色相がマイナス表示されるときの処理
  if(isNaN(hsvH)) {
    hsvH = 0;
  } else if(hsvH < 0) {
    hsvH = 360 + hsvH;
  }
  $('#js-num_hsvh').val(parseInt(hsvH));

  // 彩度を取得し設定する
  hsvS = (maxValue - minValue) / maxValue * 255;
  // rgbの値が同じとき、hsvSが数値にならないための処理
  if(isNaN(hsvS)) {
    hsvS = 0;
  }
  $('#js-num_hsvs').val(parseInt(hsvS));

  // 明度を取得し設定する
  hsvV = maxValue;
  $('#js-num_hsvv').val(parseInt(hsvV));

  paletteBg();
  hueCircle();
  paletteCircle();
}

function paletteBg() {
  // 変換計算式からパレット右上は彩度と明度が最大のため最大値と最小値は下記のようになる
  maxValue = 255;
  minValue = 0;

  // 変換計算式から色相に応じてpalette右上のRGBの値を取得し設定
  if(hsvH >= 0 && hsvH < 60) {
    paletteR = maxValue;
    paletteG = (hsvH / 60) * (maxValue - minValue) + minValue;
    paletteB = minValue;
  } else if(hsvH >= 60 && hsvH < 120) {
    paletteR = ((120 - hsvH) / 60) * (maxValue - minValue) + minValue;
    paletteG = maxValue;
    paletteB = minValue;
  } else if(hsvH >= 120 && hsvH < 180) {
    paletteR = minValue;
    paletteG = maxValue;
    paletteB = ((hsvH - 120) / 60) * (maxValue - minValue) + minValue;
  } else if(hsvH >= 180 && hsvH < 240) {
    paletteR = minValue;
    paletteG = ((240 - hsvH) / 60) * (maxValue - minValue) + minValue;
    paletteB = maxValue;
  } else if(hsvH >= 240 && hsvH < 300) {
    paletteR = ((hsvH - 240) / 60) * (maxValue - minValue) + minValue;
    paletteG = minValue;
    paletteB = maxValue;
  } else {
    paletteR = maxValue;
    paletteG = minValue;
    paletteB = ((360 - hsvH) / 60) * (maxValue - minValue) + minValue;
  }

  let paletteBg = 'linear-gradient(to top, black, transparent), linear-gradient(to left, rgb(' + paletteR + ',' + paletteG + ',' + paletteB +'), white)';
  $('#js-palette').css('background', paletteBg);
}

function hueCircle() {
  // 色相バーの幅を取得し、色相バーの幅に色相をかけて#js-hue_bar_circleの位置とpaletteRGBから色を設定
  let huebarW = $('#js-hue_bar').width();
  let cursorLeft = hsvH / 360 * huebarW;

  let hueCircleStyle = {
    'left': cursorLeft,
    'background-color': 'rgb(' + paletteR + ',' + paletteG + ',' + paletteB + ')',
  }

  $('#js-hue_bar_circle').css(hueCircleStyle);
}

function paletteCircle() {
  // パレットの幅と高さを取得し、パレットの幅と高さに応じて#js-palette_circleの位置とrgbRGBから色を設定
  let paletteW = $('#js-palette').width();
  let paletteH = $('#js-palette').height();
  let paletteCircleTop =  paletteH - (paletteH / 255 * hsvV);
  let paletteCircleLeft = hsvS / 255 * paletteW;

  let paletteCircleStyle = {
    'top': paletteCircleTop,
    'left': paletteCircleLeft,
    'background-color': 'rgb(' + rgbR + ',' + rgbG + ',' + rgbB + ')',
  }

  $('#js-palette_circle').css(paletteCircleStyle);
  $('.js-color_svg').css('fill', 'rgb(' + rgbR + ',' + rgbG + ',' + rgbB + ')');
}

function dragHuebar() {
  $('#js-hue_bar').on('touchstart mousedown', function(e) {
    // 他のイベントを発生させない処理
    e.preventDefault();

    // 色相バーの操作がタッチ操作か、マウス操作かを判定
    if (e.type === 'touchstart') {
      touchFlag = true;
    }

    // 色相バーをクリックした位置の色相を取得し、色相バーのカーソル・色相とRGBの入力フォームを設定
    $('body').css('user-select', 'none');
    changeFue(e);

    if(touchFlag) {
      $(window).on('touchmove', function(e) {
        // 色相バーをクリックした位置の色相を取得し、色相バーのカーソル・色相とRGBの入力フォームを設定
        changeFue(e);
      });

      $(window).on('touchend', function() {
        // イベントのリセット
        $(window).off('touchmove');
        $(window).off('touchend');
        $('body').css('user-select', 'auto');
      });
    } else {
      $(window).on('mousemove', function(e) {
        // 色相バーをクリックした位置の色相を取得し、色相バーのカーソル・色相とRGBの入力フォームを設定
        changeFue(e);
      });

      $(window).on('mouseup', function() {
        // イベントのリセット
        $(window).off('mousemove');
        $(window).off('mouseup');
        $('body').css('user-select', 'auto');
      });
    }
  });
}

function changeFue(e) {
  // 色相バーの幅や、タッチ操作もしくはマウス操作で使用する変数の設定
  let huebarW = $('#js-hue_bar').width();
  let offSet = $('#js-hue_bar').offset();
  let cursorLeft;

  // タッチ操作かマウス操作かによって使用するjsが異なるため分岐
  if(touchFlag) {
    cursorLeft = e.changedTouches[0].pageX - offSet.left;
  } else {
    cursorLeft = e.pageX - offSet.left;
  }

  // 色相バー内でカーソルを収める設定
  if(cursorLeft <= 0) {
    cursorLeft = 0;
  } else if(cursorLeft >= huebarW) {
    cursorLeft = huebarW;
  }

  // 色相の設定
  hsvH = parseInt(cursorLeft / huebarW * 360);
  $('#js-num_hsvh').val(parseInt(hsvH));

  // 設定した色相に応じてRGBを変更する
  returnRGB();
}

function dragPalette() {
  $('#js-palette').on('touchstart mousedown', function(e) {
    // 他のイベントを発生させない処理
    e.preventDefault();

    // パレットの操作がタッチ操作か、マウス操作かを判定
    if (e.type === 'touchstart') {
      touchFlag = true;
    }

    // パレットをクリックした位置の彩度と明度を取得し、パレットのカーソル・彩度と明度とHSVの入力フォームを設定
    $('body').css('user-select', 'none');
    changePalette(e);

    if(touchFlag) {
      $(window).on('touchmove', function(e) {
        // 色相バーをクリックした位置の色相を取得し、色相バーのカーソル・色相とRGBの入力フォームを設定
        changePalette(e);
      });

      $(window).on('touchend', function() {
        // イベントのリセット
        $(window).off('touchmove');
        $(window).off('touchend');
        $('body').css('user-select', 'auto');
      });
    } else {
      $(window).on('mousemove', function(e) {
        // 色相バーをクリックした位置の色相を取得し、色相バーのカーソル・色相とRGBの入力フォームを設定
        changePalette(e);
      });

      $(window).on('mouseup', function() {
        // イベントのリセット
        $(window).off('mousemove');
        $(window).off('mouseup');
        $('body').css('user-select', 'auto');
      });
    }
  });
}

function changePalette(e) {
  // パレットの幅や高さ、タッチ操作もしくはマウス操作で使用する変数の設定
  let paletteW = $('#js-palette').width();
  let paletteH = $('#js-palette').height();
  let offSet = $('#js-palette').offset();
  let paletteCircleTop;
  let paletteCircleLeft;

  // タッチ操作かマウス操作かによって使用するjsが異なるため分岐
  if(touchFlag) {
    paletteCircleTop = e.changedTouches[0].pageY - offSet.top;
    paletteCircleLeft = e.changedTouches[0].pageX - offSet.left;
  } else {
    paletteCircleTop = e.pageY - offSet.top;
    paletteCircleLeft = e.pageX - offSet.left;
  }

  // パレット内でカーソルを収める設定
  if(paletteCircleTop <= 0) {
    paletteCircleTop = 0;
  } else if(paletteCircleTop >= paletteH) {
    paletteCircleTop = paletteH;
  }
  if(paletteCircleLeft <= 0) {
    paletteCircleLeft = 0;
  } else if(paletteCircleLeft >= paletteW) {
    paletteCircleLeft = paletteW;
  }

  // 彩度の設定
  hsvS = parseInt(paletteCircleLeft / paletteW * 255);
  $('#js-num_hsvs').val(parseInt(hsvS));

  // 明度の設定
  hsvV = 255 - parseInt(paletteCircleTop / paletteH * 255);
  $('#js-num_hsvv').val(parseInt(hsvV));

  // 設定した色相に応じてRGBを変更する
  returnRGB();
}